#include "lcd.h"
#include <p18f4550.h>



void delay_ms (int n) {
	
	unsigned int i,j;	

	for (i = 0; i < n * OSC_FREQ; i++) {
		for (j = 0; j < 12; j++);
	}
	
}


//this function specify the dalay for character register
void delay_cycles(int n){
	while(n>0){
		Nop();
		n--;
	}
}

///////////////////////////////////////////////////////////
//this function specify the dalay and the strobe used for 4bit mode
void strobe(void){
	EN = 1;
	delay_cycles(DELAY_STROBE_CYCLES);
	EN = 0;
}

///////////////////////////////////////////////////////////
//write to character register of lcd module
void data(unsigned char c){ 
	RS=1;
	delay_ms(DELAY_DATA);
	send(c);
}

///////////////////////////////////////////////////////////
//write to command register of lcd module
void cmd(unsigned char c){ 
	RS=0;
	delay_ms(DELAY_CMD);
	send(c);
}

///////////////////////////////////////////////////////////
//send to data port the bits for commands and character register
void send(unsigned char c){
	DATA = ( c >> 4 );strobe();
	DATA = ( c );strobe(); 
}

///////////////////////////////////////////////////////////
//clear the screen and wait a period
void clear(void){
	cmd(CLEAR_SCREEN);
	delay_ms(DELAY_INIT);
}

///////////////////////////////////////////////////////////
//the function initialize the lcd module in 4 bits mode
void init_lcd(){
	//Set the port directions
	DIRDATA=0;
	DIRRS=0;
	DIREN=0;
	DATA=0;
	RS=0;
	EN=0;
	cmd(START);
	delay_ms(DELAY_INIT);
	cmd(START);
	cmd(START);
	cmd(MODE); // 4-bit interface, more than one line, 5*7 Pixels
	cmd(INVISIBLE); // set the cursor
	clear(); // clear screen
	cmd(FIRSTLINE); // go to first line
}

///////////////////////////////////////////////////////////
/*write to the lcd module a string in the format
'text' + '\0' while \n means go to next line*/
void print_lcd(unsigned char *str){
	while(*str!='\0'){
		if(*str=='\n'){
			cmd(NEXT_LINE);
			str++;
		}
		else
			data(*str++);
	}
	delay_ms(200);
}